﻿(function (hdWidget) { // Anonymous "self-invoking" function

	var domWidget; //"contact us" tab
	var domNewTicket; //new ticket form window
	var isShown = false;
	var height = 334; //had to use fixed height for smoother animation and cross-browser support
	var isMobile = false;
	//get helpdesk url
	var loadedscripts = document.getElementsByTagName("script");
	var helpdeskUrl = loadedscripts[loadedscripts.length - 1].src;
	helpdeskUrl = helpdeskUrl.split('/').slice(0, -1).join('/');
	helpdeskUrl = helpdeskUrl.split('/').slice(0, -1).join('/') + '/';

	//load jquery if it's not loaded
	if (!window.jQuery) {
		var script = document.createElement("SCRIPT");
		script.src = 'https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js';
		script.type = 'text/javascript';
		document.getElementsByTagName("head")[0].appendChild(script);
	}

	// Poll for jQuery to come into existance
	var counter = 0;
	var checkReady = function (callback) {
		if (window.jQuery) {
			callback(); //jquery loaded!! launch callback
		}
		else {
			counter++;
			if (counter > 10) return; //not loaded in 10 attempts - prevent endless loop
			window.setTimeout(function () { checkReady(callback); }, 200);
		}
	};

	// Start polling...
	checkReady(function () {
		//jquery loaded!!!
		jQuery(function () {
			setDefaults();
			initWidget();
			StyleWidget();
			slideOut();
		});
	});

	function initWidget() {
		domWidget = jQuery("<a></a>");
		domWidget.attr('href', helpdeskUrl + 'Tickets/New');
		domWidget.html(hdWidget.text + '<img style="margin-left:10px;width:12px;" src="' + helpdeskUrl + 'images/up_arrow.png" />');
		isMobile = jQuery(window).width() < 500;

		var iframeUrl = helpdeskUrl + 'Tickets/NewWidget?ReferrerUrl=' + encodeURIComponent(window.location.href) + "&bgcolor=" + encodeURIComponent(hdWidget.bgColor);

		domNewTicket = jQuery('<div><iframe id="hdWidgetFrame" style="border:0" width="350" src="' + iframeUrl + '"></iframe></div>');

		domWidget.click(function (e) { e.preventDefault(); ToggleWidget(); });
	}

	function ToggleWidget() {
		if (!isShown) { //show
			domNewTicket.animate({ bottom: '0' });
			domWidget.animate({ bottom: height + 'px' });
			domWidget.find("img").attr("src", helpdeskUrl + "images/down_arrow.png");
			isShown = true;
		} else { //hide
			isShown = false;
			domNewTicket.animate({ bottom: '-' + (height - 10) + 'px' });
			domWidget.animate({ bottom: '10px' });
			domWidget.find("img").attr("src", helpdeskUrl + "images/up_arrow.png");
		}
		return false;
	}

	function setDefaults() {
		var defaults = {
			text: "Contact us",
			position: "right",
			bgColor: "#444",
			fgColor: "#ffffff",
			borderColor: "#fff"
		}
		hdWidget = jQuery.extend(defaults, hdWidget);
	}

	function StyleWidget() {
		domNewTicket.css({
			position: "fixed",
			"border-top-right-radius": "10px",
			'border': '3px solid ' + hdWidget.borderColor,
			'border-bottom': 0,
			bottom: '-' + (height - 10) + 'px',
			"overflow": 'hidden',
			height: height + "px",
			"z-index": 9999,
            "box-sizing": "content-box"
		});

		jQuery("iframe", domNewTicket).css({
			"overflow-y": 'hidden',
			"border-top-right-radius": "10px",
			"border-left": "1px solid #444",
			"border-right": "1px solid #444",
			height: height + "px"
		});

		domWidget.css({
			display: 'block',
			position: 'fixed',
			bottom: '10px',
			'font-size': '14px',
			'background-color': hdWidget.bgColor,
			color: hdWidget.fgColor,
			padding: '10px 30px',
			"padding-bottom": 0,
			'text-decoration': 'none',
			'font-weight': 'bold',
			'border': '3px solid ' + hdWidget.borderColor,
			'border-bottom': 'none',
			'border-top-left-radius': '10px 15px',
			'border-top-right-radius': '10px',
			'font-family': 'sans-serif',
			"z-index": 9999
		});

		if (!isMobile) {
			if (hdWidget.position == "left") {
				domNewTicket.css("left", '100px');
			}
			else {
				domNewTicket.css("right", '100px');
			}
		}

		if (isMobile) {
			domNewTicket.css({
				"width": "100%"
			})
			jQuery("iframe", domNewTicket).css("width", "100%");
		}
	}

	function slideOut() {
		domNewTicket.css({ "bottom": "-=50" });
		domWidget.css({ "bottom": "-=50" });
		jQuery("body").append(domNewTicket);
		jQuery("body").append(domWidget);

		//we need to wait a second for DOM to refresh
		setTimeout(function () {
			//position "contact us" depending on its width
			if (!isMobile) {
				if (hdWidget.position == "left")
					domWidget.css({ left: "100px" })
				else
					domWidget.css({ right: 458 - domWidget.outerWidth() + "px" })
			}

			//pretty initial slide out
			domNewTicket.animate({ "bottom": "+=50" });
			domWidget.animate({ "bottom": "+=50" });
		}, 1000);
	}
})(typeof hdWidget === 'undefined' ? {} : hdWidget);