﻿//call this func to resize a textbox to it's content height
function AutoResize(elem) {
	var scrollHeight = elem.scrollHeight;
	if (scrollHeight > elem.clientHeight > 0 && elem.clientHeight < 350) {
		elem.style.height = (scrollHeight + 6) + "px";
	}
}

//call this func to resize editable ifram to it's content height
function AutoResizeEditableIframe(oFrame) {
	var bodyObj = oFrame.contentWindow.document.body;
	var scrollHeight = bodyObj.scrollHeight;
	if (scrollHeight > bodyObj.clientHeight) {
		if (bodyObj.clientHeight < 350) {
			bodyObj.style.overflowY = 'hidden'; //to prevent annoying flickering
			oFrame.style.height = (scrollHeight + 6) + "px";
		}
		else
			bodyObj.style.overflowY = 'auto';
	}
}

//this function moves not by character, but by element, including <br> and textnodes
function SetCaretPositionInIframe(ifr, pos) {
	var win = ifr.contentWindow;
	win.focus();
	win.document.body.focus();
	if (!pos || pos <= 1) return;
	if (typeof (win.document.createRange) != "function") //ie 8 doesn't support it
		return;
	var range = win.document.createRange();
	range.setStart(win.document.body, pos);
	range.setEnd(win.document.body, pos);
	win.document.body.focus();
	win.getSelection().removeAllRanges();
	win.getSelection().addRange(range);
}

//Important! pass an ARRAY OF ARRAYS into "postData", like this [[key1,value1],[key2,value2]]
function RedirectAndSendPost(url, postData) {
	var strHtml = '<form action="' + url + '" method="post">';
	for (var i=0; i< postData.length; i++) {
		strHtml += '<input name="' + postData[i][0] + '" value="' + postData[i][1] + '" />';
	}
	strHtml += "</form>"

	var form = $(strHtml);
	$('body').append(form);
	form.submit();
}

function DecodeHtml(str) {
	var element = document.createElement('div');
	element.innerHTML = str;
	return element.innerText || element.textContent;
}

function getQueryString() {
	var result = {}, queryString = location.search.substring(1),
		re = /([^&=]+)=([^&]*)/g, m;

	while (m = re.exec(queryString)) {
		if (result[decodeURIComponent(m[1])]) //already present in the dictionary - means it's an "array" query string, like url?a=1&a=2&a=3
		{
			var existingVal = result[decodeURIComponent(m[1])];
			if (existingVal.constructor === Array) //existing val is already an array
				existingVal.push(decodeURIComponent(m[2]))
			else {
				var arr = [];
				arr.push(result[decodeURIComponent(m[1])]);
				arr.push(decodeURIComponent(m[2]));
				result[decodeURIComponent(m[1])] = arr;
			}
		}
		else
			result[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
	}

	return result;
}

var gridPopup = new function () {

	var currentCb = null;

	this.MovePopup = function (elem) {
		var selectedRowsCount = $(".cb:checked").not(".cbAll").length;
		var popup = $("#bulk-actions-popup");

		if (selectedRowsCount == 0) { popup.fadeOut(100); currentCb = null; return; } //nothing is selected, hiding
		else if (selectedRowsCount == 1) { $("li.multiple").hide(); } //single ticket selected, hide bulk actions
		else { $("li.multiple").fadeIn(); } //more than one ticket is selected, show every action


		//always recalculate horizontal position
		popup.css("right", $(window).width() - $(elem).offset().left + 15);

		if (elem.checked) { //do not move popup to the unchecked element
			popup.animate({ top: $(elem).offset().top - 24 }, 100);
		}
			//current cb was unchecked, we should move away somewhere
		else if (!elem.checked && $(elem).get(0) === $(currentCb).get(0)) {
			//at this point we have at least one other checked checkbox
			//findin the closest checked element; index of the current CB in array of all CBs
			var curIndex = $.inArray($(elem)[0], $(".cb"));
			//indexes of all checked CBs
			var checked = $(".cb").map(function (i, elem) { if (elem.checked) return i; });
			var closest = FindClosestNumber(checked, curIndex);
			//recursively moving
			MovePopup($(".cb")[closest]);
			return;
		}
		else { return; }

		currentCb = elem;
		popup.fadeIn(50);
	}

	this.ResetCurrentCb = function() { currentCb = null; }
}

function ProcessCtrlEnter(e, btnId) {
	var evt = e ? e : window.event;
	if (evt.ctrlKey) {
		var keyCode = evt.keyCode ? evt.keyCode : evt.which;
		if (keyCode == 13) {
			$("#" + btnId).click();
			return false;
		}
		else
			return true;
	}
	else
		return true;
}