CREATE RESOURCE POOL ReportPool
WITH
(MIN_CPU_PERCENT=0,
MAX_CPU_PERCENT=25)
GO

CREATE WORKLOAD GROUP ReportGroup
USING ReportPool ;
GO

CREATE FUNCTION dbo.UDFClassifier()
RETURNS SYSNAME
WITH SCHEMABINDING
AS
BEGIN
	DECLARE @WorkloadGroup AS SYSNAME
	IF(SUSER_NAME() = 'hosted_hd_report_user')
		SET @WorkloadGroup = 'ReportGroup'
	ELSE
		SET @WorkloadGroup = 'default'
	RETURN @WorkloadGroup
END
GO

ALTER RESOURCE GOVERNOR
WITH (CLASSIFIER_FUNCTION=dbo.UDFClassifier);
GO
ALTER RESOURCE GOVERNOR RECONFIGURE
GO

--http://blog.sqlauthority.com/2012/06/04/sql-server-simple-example-to-configure-resource-governor-introduction-to-resource-governor/

--cleanup script:
/*
ALTER RESOURCE GOVERNOR WITH (CLASSIFIER_FUNCTION = NULL)
GO
ALTER RESOURCE GOVERNOR DISABLE
GO
DROP FUNCTION dbo.UDFClassifier
GO
DROP WORKLOAD GROUP ReportGroup
GO
DROP RESOURCE POOL ReportPool
GO
ALTER RESOURCE GOVERNOR RECONFIGURE
GO
*/