CREATE table #Issues(IssueID INT PRIMARY key)

insert into #Issues --issues to be transfered
select IssueID FROM hdIssues WITH(NOLOCK) where InstanceID=@InstanceID

SET IDENTITY_INSERT #DBName#.dbo.hdCompanies ON
INSERT INTO #DBName#.dbo.hdCompanies (CompanyID, InstanceID,  [Name], CRMID,EmailDomain,Notes)
SELECT CompanyID, 0 as InstanceID,  [Name], CRMID,EmailDomain,Notes FROM hdCompanies where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdCompanies OFF

SET IDENTITY_INSERT #DBName#.dbo.Departments ON
INSERT INTO #DBName#.dbo.Departments (DepartmentID, InstanceID,  [Name])
SELECT DepartmentID, 0 as InstanceID,  [Name] FROM Departments where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.Departments OFF

SET IDENTITY_INSERT #DBName#.dbo.hdCategories ON
INSERT INTO #DBName#.dbo.hdCategories ([CategoryID],[Name],[SectionID],[InstanceID],[ForTechsOnly],ForSpecificUsers,OrderByNumber,FromAddress)
SELECT [CategoryID],[Name],[SectionID], 0 as InstanceID,[ForTechsOnly],ForSpecificUsers,OrderByNumber,FromAddress FROM hdCategories where InstanceID=@InstanceID
update #DBName#.dbo.hdCategories set instanceid=0
SET IDENTITY_INSERT #DBName#.dbo.hdCategories OFF

SET IDENTITY_INSERT #DBName#.dbo.hdIssues ON
INSERT INTO #DBName#.dbo.hdIssues (IssueID,InstanceID,IssueDate,UserID,CategoryID,ResolvedDate,AssignedToUserID,Subject,Body,UpdatedByUser,UpdatedByPerformer,StatusID,Priority,StartDate,LastUpdated,DueDate,TimeSpentInSeconds,UpdatedForTechView, Origin)
SELECT IssueID,0 as InstanceID,IssueDate,UserID,CategoryID,ResolvedDate,AssignedToUserID,Subject,Body,UpdatedByUser,UpdatedByPerformer,StatusID,Priority,StartDate,LastUpdated,DueDate,TimeSpentInSeconds,UpdatedForTechView, Origin FROM hdIssues where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdIssues OFF

WAITFOR DELAY '00:00:05'

--batch-insert in chunks of 5000
SET IDENTITY_INSERT #DBName#.dbo.hdComments ON
declare @startid int = 0
WHILE 1 = 1
BEGIN
	INSERT INTO #DBName#.dbo.hdComments WITH (TABLOCK) ([CommentID], [IssueID],  [CommentDate] , [UserID], [Body] ,  [ForTechsOnly], [IsSystem] , Recipients ,  EmailHeaders)
	SELECT TOP 5000 [CommentID], [IssueID],  [CommentDate] , [UserID], [Body] ,  [ForTechsOnly], [IsSystem] , Recipients ,  EmailHeaders
	FROM hdComments WHERE IssueID in (select IssueID FROM #Issues)
	and CommentID>@startid
	IF (@@ROWCOUNT = 0) BREAK;

	SELECT @startid = MAX(CommentID) FROM #DBName#.dbo.hdComments
	
	WAITFOR DELAY '00:00:02'
END
SET IDENTITY_INSERT #DBName#.dbo.hdComments OFF
--end batch-insert

SET IDENTITY_INSERT #DBName#.dbo.hdCommentTemplates ON
INSERT INTO #DBName#.dbo.hdCommentTemplates ([TemplateID],[InstanceID],[Body],[Name])
SELECT [TemplateID],0 as [InstanceID],[Body],[Name] FROM hdCommentTemplates WHERE InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdCommentTemplates OFF

SET IDENTITY_INSERT #DBName#.dbo.hdFileAttachments ON
INSERT INTO #DBName#.dbo.hdFileAttachments([FileID],[IssueID],[UserID],[FileName],[FileData], CommentID, DropboxUrl, FileHash, FileSize, HiddenFromKB, HiddenFromTickets, AssetID)
SELECT [FileID],[IssueID],[UserID],[FileName],[FileData],CommentID,DropboxUrl,FileHash,FileSize,HiddenFromKB,HiddenFromTickets, AssetID FROM hdFileAttachments WHERE IssueID in (select IssueID FROM #Issues)
SET IDENTITY_INSERT #DBName#.dbo.hdFileAttachments OFF

INSERT INTO #DBName#.dbo.hdIssueSubscribers SELECT * FROM hdIssueSubscribers WHERE IssueID in (select IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.SecondaryAssignees SELECT * FROM SecondaryAssignees WHERE IssueID in (select IssueID FROM #Issues)

WAITFOR DELAY '00:00:02'

INSERT INTO #DBName#.dbo.hdCustomFieldValues SELECT * FROM hdCustomFieldValues WHERE IssueID in (select IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.hdCustomFieldValuesForAssets SELECT * FROM hdCustomFieldValuesForAssets WHERE ItemID in (select ItemID FROM hdAssets where InstanceID=@InstanceID)

WAITFOR DELAY '00:00:02'

INSERT INTO #DBName#.dbo.hdIssueSchedule ([IssueID],[FreqType],[FirstRecurrenceDate],[PrevRepeatsCount],ReopenOriginal)
SELECT [IssueID],[FreqType],[FirstRecurrenceDate],[PrevRepeatsCount],ReopenOriginal FROM hdIssueSchedule WHERE IssueID in (select IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.KBArticles ([ArticleID],[InstanceID],[CategoryID],[Subject],[Body] ,[ForTechsOnly],OrderByNumber,DateCreated,LastUpdated)
SELECT [ArticleID], 0 as InstanceID,[CategoryID],[Subject],[Body] ,[ForTechsOnly],OrderByNumber,DateCreated,LastUpdated FROM KBArticles WHERE InstanceID=@InstanceID

INSERT INTO #DBName#.dbo.hdLinkedIssues(Issue1ID,Issue2ID)
SELECT Issue1ID,Issue2ID FROM hdLinkedIssues where Issue1ID in (select Issue1ID FROM #Issues)

INSERT INTO #DBName#.dbo.hdMergedIssues(IssueID,IssueMergedID)
SELECT IssueID,IssueMergedID FROM hdMergedIssues where IssueID in (select IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.hdScheduledIssues(ScheduledIssueID,OriginalIssueID)
SELECT ScheduledIssueID,OriginalIssueID FROM hdScheduledIssues where OriginalIssueID in (select IssueID FROM #Issues)

SET IDENTITY_INSERT #DBName#.dbo.hdAssetManufacturers ON
INSERT INTO #DBName#.dbo.hdAssetManufacturers(ManufacturerID,InstanceID,[Name])
SELECT ManufacturerID,0 as InstanceID,[Name] FROM hdAssetManufacturers where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdAssetManufacturers OFF

SET IDENTITY_INSERT #DBName#.dbo.hdAssets ON
INSERT INTO #DBName#.dbo.hdAssets (ItemID,InstanceID,ModelName,TypeID,ManufacturerID,Quantity,SupplierID,SerialNumber,Location,Comments)
SELECT ItemID,0 as InstanceID,ModelName,TypeID,ManufacturerID,Quantity,SupplierID,SerialNumber,Location,Comments FROM hdAssets where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdAssets OFF

SET IDENTITY_INSERT #DBName#.dbo.hdAssetSuppliers ON
INSERT INTO #DBName#.dbo.hdAssetSuppliers(SupplierID,InstanceID,[Name])
SELECT SupplierID,0 as InstanceID,[Name] FROM hdAssetSuppliers where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdAssetSuppliers OFF

SET IDENTITY_INSERT #DBName#.dbo.hdAssetTypes ON
INSERT INTO #DBName#.dbo.hdAssetTypes(TypeID,InstanceID,[Name])
SELECT TypeID,0 as InstanceID,[Name] FROM hdAssetTypes where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdAssetTypes OFF

SET IDENTITY_INSERT #DBName#.dbo.hdTags ON
INSERT INTO #DBName#.dbo.hdTags(TagID,[Name],InstanceID)
SELECT TagID,[Name],0 FROM hdTags where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdTags OFF

WAITFOR DELAY '00:00:02'

INSERT INTO #DBName#.dbo.hdIssueTags SELECT * FROM hdIssueTags where IssueID in (SELECT IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.hdAssetUsers SELECT * FROM hdAssetUsers where UserID in (SELECT UserID FROM hdUsers where InstanceID=@InstanceID)

INSERT INTO #DBName#.dbo.hdAssetsIssues SELECT * FROM hdAssetsIssues where IssueID in (SELECT IssueID FROM #Issues)

WAITFOR DELAY '00:00:02'

INSERT INTO #DBName#.dbo.hdOnBehalfIssues SELECT * FROM hdOnBehalfIssues where IssueID in (SELECT IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.hdCategoryPermissions SELECT * FROM hdCategoryPermissions where CategoryID IN (select CategoryID FROM hdCategories where InstanceID=@InstanceID)

INSERT INTO #DBName#.dbo.hdCategorySubmitPermissions SELECT * FROM hdCategorySubmitPermissions where CategoryID IN (select CategoryID FROM hdCategories where InstanceID=@InstanceID)

WAITFOR DELAY '00:00:02'

INSERT INTO #DBName#.dbo.CustomFieldCategories SELECT * FROM CustomFieldCategories where CategoryID IN (select CategoryID FROM hdCategories where InstanceID=@InstanceID)

SET IDENTITY_INSERT #DBName#.dbo.hdCustomFieldOptions ON
INSERT INTO #DBName#.dbo.hdCustomFieldOptions([OptionID],[FieldID],[OptionValue],IsDefault, OrderByNumber,IsDisabled)
SELECT [OptionID],[FieldID],[OptionValue],IsDefault,OrderByNumber,IsDisabled FROM hdCustomFieldOptions WHERE FieldID IN (SELECT FieldID FROM hdCustomFields where InstanceID=@InstanceID)
SET IDENTITY_INSERT #DBName#.dbo.hdCustomFieldOptions OFF

SET IDENTITY_INSERT #DBName#.dbo.hdCustomFields ON
INSERT INTO #DBName#.dbo.hdCustomFields([FieldID],[InstanceID],[Type],[FieldName],[ForTechsOnly],[Mandatory],[OrderByNumber], ShowInGrid, UsageType)
SELECT [FieldID],0 as [InstanceID],[Type],[FieldName],[ForTechsOnly],[Mandatory],[OrderByNumber], ShowInGrid, UsageType FROM hdCustomFields where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdCustomFields OFF

WAITFOR DELAY '00:00:02'

SET IDENTITY_INSERT #DBName#.dbo.hdUsers ON
INSERT INTO #DBName#.dbo.hdUsers ([UserID],[InstanceID],[UserName],[Email],[Password],[IsAdministrator],[FirstName] ,[LastName],CompanyID,[Notes],[Phone],[Location],[SendEmail],Disabled,LastSeen,IPAddress,HostName,Lang,UserAgent,[Signature],Greeting,DepartmentID,IsManager,PushToken,TechTutorialShown,AdminTutorialShown,TwoFactorAuthEnabled, PushPlatform, TimezoneID)
SELECT [UserID], 0 as [InstanceID],[UserName],[Email],[Password],[IsAdministrator],[FirstName] ,[LastName],CompanyID,[Notes],[Phone],[Location],[SendEmail],Disabled,LastSeen,IPAddress,HostName,Lang,UserAgent,[Signature],Greeting,DepartmentID,IsManager,PushToken,TechTutorialShown,AdminTutorialShown,TwoFactorAuthEnabled, PushPlatform, TimezoneID FROM hdUsers where InstanceID=@InstanceID
update  #DBName#.dbo.hdUsers set instanceid=0
SET IDENTITY_INSERT #DBName#.dbo.hdUsers OFF

WAITFOR DELAY '00:00:02'

SET IDENTITY_INSERT #DBName#.dbo.hdSections ON
INSERT INTO #DBName#.dbo.hdSections([SectionID],[Name],[InstanceID],OrderByNumber)
SELECT [SectionID],[Name],0 as [InstanceID],OrderByNumber FROM hdSections where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdSections OFF

SET IDENTITY_INSERT #DBName#.dbo.hdStatus ON
INSERT INTO #DBName#.dbo.hdStatus([StatusID],InstanceID,[Name],[ButtonCaption],[ForTechsOnly], StopTimeSpent)
SELECT [StatusID],0 as InstanceID,[Name],[ButtonCaption],[ForTechsOnly], StopTimeSpent FROM hdStatus where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdStatus OFF

SET IDENTITY_INSERT #DBName#.dbo.hdPOPServers ON
INSERT INTO #DBName#.dbo.hdPOPServers(ServerID,[InstanceID],HostName,POPLogin,POPPassword,Port,UseSSL,NewTicketsCategoryID,IsImap,[Disabled],ImapMarkSeenNotDelete)
SELECT ServerID,0 as [InstanceID],HostName,POPLogin,POPPassword,Port,UseSSL,NewTicketsCategoryID,IsImap,[Disabled],ImapMarkSeenNotDelete FROM hdPOPServers where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.hdPOPServers OFF

INSERT INTO #DBName#.dbo.ReportSchedule SELECT * FROM ReportSchedule where InstanceID=@InstanceID
update #DBName#.dbo.ReportSchedule SET InstanceID=0

INSERT INTO #DBName#.dbo.hdSettings (InstanceID,EmailNotificationsEnabled,SMTPServer,SMTPAuthRequired,SMTPUserName,SMTPPassword,SMTPUseSSL,FromAddress,AllowUserRegistration,SMTPPort,MailCheckerNewIssuesCategoryID,MailCheckerAllowUnregisteredUsers,RestrictIssueDeletion,Lang,MaxAttachSize,RestrictIssueClosing,NewIssuesDefaultCategoryID,AllowGuestSubmission,AllowAnonymousKBAccess,SeeEveryonesIssues,UseDefaultSmtp,HeaderBGColor,MenuBarBGColor,LogoImage,SendTechniciansEmailOnNewIssue,ReplyToAddress,FromName,DisableKB,AutoLoginSharedSecret,MenuBarTextColor,DisableCloseNotification,Title,DisableAssets,DaysToCloseAfter,CRMRootUrl,CRMSharedKey,UseFromNameForUserOriginatedMsgs,HeaderTextColor,SameCompanyUserPermission,HidePoweredBy,DisableAvatars,SendAdminEmailOnNewIssue,SendTechSMSOnNewIssue,AutoAssignFirstReplier,DontReopenOnReply,NotifyAllTechsOnReply,NewTicketNote,CustomCSS,DisableAutoTimer,DontAddCCToSubscribers,WorkHourFrom,WorkHourTo,EmailOtherTechsOnTakeover,EnableSaml,SamlEndpoint,SamlCertificate,DisableTicketConfirmationNotification,TimezoneID,ActiveTabTextColor,RemoteLoginURL,NoAttachmentsInNotifications,DisableAutologinLinks,ExtractOriginalSenderFromFwd, FaviconImage, EnableGoogleLogin, DisableUsernameEmailEdit, KBTitle, KBCss, KBHeadCode, SendTechEmailOnKBUpdate, HideLoginButtonWhenSAML, CustomJS, EnableMultiAsssign, LogoUrl)
SELECT * FROM hdSettings where InstanceID=@InstanceID
update #DBName#.dbo.hdSettings SET InstanceID=0

INSERT INTO #DBName#.dbo.Integrations ([InstanceID], BitbucketEnabled, BitbucketUsername, BitbucketPassword, HipChatEnabled, HipChatAuthToken, HipChatRoomId, JiraEnabled, JiraUsername, JiraPassword, JiraUrl, DropboxEnabled, DropboxAppID, SlackEnabled, SlackWebhookURL, GitHubEnabled,	GitHubUsername,	GitHubPassword, UserLookupEnabled, UserLookupURL, AsanaEnabled, AsanaAccessToken, TrelloEnabled, VSOEnabled, VSOAccountName, VSOUsername, VSOToken, HarvestEnabled, HarvestUsername, HarvestPassword, HarvestAccount, ZapierEnabled, UserLookupBasicAuthEnabled, UserLookupUsername, UserLookupPassword, GoogleDriveEnabled,  GoogleAPIKey, GoogleOAuthClientID, GithubEnterpriseUrl)
SELECT * FROM Integrations where InstanceID=@InstanceID
update #DBName#.dbo.Integrations SET InstanceID=0

INSERT INTO #DBName#.dbo.IntegrationTicketData (IssueID, BitbucketIssueUrl, JiraIssueUrl, GitHubIssueUrl, AsanaTaskUrl, TrelloCardUrl, VSOWorkItemUrl, HarvestProjectUrl)
SELECT * FROM IntegrationTicketData WHERE IssueID IN (select IssueID FROM #Issues)

INSERT INTO #DBName#.dbo.EmailTemplates SELECT * FROM EmailTemplates where InstanceID=@InstanceID
update #DBName#.dbo.EmailTemplates SET InstanceID=0


SET IDENTITY_INSERT #DBName#.dbo.AutomationRules ON
INSERT INTO #DBName#.dbo.AutomationRules(RuleID, InstanceID,RuleXml, OrderByNumber)
SELECT * FROM AutomationRules where InstanceID=@InstanceID
SET IDENTITY_INSERT #DBName#.dbo.AutomationRules OFF

DROP table #Issues

use #DBName#

--creating foreign keys
ALTER TABLE [dbo].[hdCategoryPermissions] ADD 
  CONSTRAINT [FK_hdCategoryPermissions_hdCategories] FOREIGN KEY([CategoryID]) REFERENCES [dbo].[hdCategories] ([CategoryID]),
  CONSTRAINT [FK_hdCategoryPermissions_hdUsers] FOREIGN KEY([UserID]) REFERENCES [dbo].[hdUsers] ([UserID])


ALTER TABLE [dbo].[hdComments] ADD 
  CONSTRAINT [FK_hdComments_hdIssues] FOREIGN KEY([IssueID]) REFERENCES [dbo].[hdIssues] ([IssueID]),
  CONSTRAINT [FK_hdComments_hdUsers] FOREIGN KEY([UserID]) REFERENCES [dbo].[hdUsers] ([UserID])


ALTER TABLE [dbo].[hdIssues] ADD 
  CONSTRAINT [FK_hdIssues_hdCategories] FOREIGN KEY([CategoryID]) REFERENCES [dbo].[hdCategories] ([CategoryID]),
  CONSTRAINT [FK_hdIssues_hdStatus] FOREIGN KEY([StatusID]) REFERENCES [dbo].[hdStatus] ([StatusID]),
  CONSTRAINT [FK_hdIssues_hdUsers1] FOREIGN KEY([UserID]) REFERENCES [dbo].[hdUsers] ([UserID]),
  CONSTRAINT [FK_hdIssues_hdUsers3] FOREIGN KEY([AssignedToUserID]) REFERENCES [dbo].[hdUsers] ([UserID])

